# an example of list
x = [1, 5, -3, 0, 2, 7]

# iterating over x elements with while loop
i = 0
while i < len(x):
    print(i, x[i])
    i = i+1

# iterating over x elements with for loop
for elem in x:
    print(elem)

# iterating over x elements with for loop and index
for i in range(len(x)):
    print(i, x[i])

# matplotlib is very popular library for plotting
# You will need to install it on your computer
# The lab computers should have it pre-installed
import matplotlib.pyplot 

# GDP per capita of Australia in USD from 1960 to 2021
# Source: datacommons.org and The World Bank
gdp_au = [1811, 1878, 1855, 1967, 2131, 2281, 2344, 
        2580, 2724, 2991, 3305, 3495, 3949, 4771, 
        6483, 7004, 7487, 7776, 8253, 9294, 10209, 
        11853, 12779, 11515, 12421, 11441, 11391, 
        11651, 14284, 17834, 18250, 18860, 18625, 
        17700, 18130, 20447, 22020, 23645, 21478, 
        20699, 21853, 19682, 20291, 23706, 30820, 
        34461, 36571, 41024, 49681, 42810, 52132, 
        62599, 68047, 68156, 62515, 56709, 49877, 
        53934, 57207, 54941, 51722, 60445]

# GDP per capita of USA in USD from 1960 to 2021
# Source: datacommons.org and The World Bank
gdp_us = [3007, 3067, 3244, 3375, 3574, 3828, 4146, 
          4336, 4696, 5032, 5234, 5609, 6094, 6726, 
          7226, 7801, 8592, 9453, 10565, 11674, 
          12575, 13976, 14434, 15544, 17121, 18237, 
          19071, 20039, 21417, 22857, 23889, 24342, 
          25419, 26387, 27695, 28691, 29968, 31459, 
          32854, 34515, 36330, 37134, 37998, 39490, 
          41725, 44123, 46302, 48050, 48570, 47195, 
          48651, 50066, 51784, 53291, 55124, 56763, 
          57867, 59908, 62823, 65120, 63529, 70219]

years = range(1960, 2022)
# plotting GDP of Australia over the years
matplotlib.pyplot.plot(years, gdp_us)

def find_peak(seq):
    """ 
        Find index of the maximum peak in a sequence
    """
    peak_id = 0
    for i in range(len(seq)):
        if seq[i] > seq[peak_id]:
            peak_id = i
    return peak_id

# find the year in which Australia had the higest GDP
print(find_peak(gdp_au) + 1960)

def linear_regression(x, y):
    """find the straight line fitting
    best to x and y,
    Assume x and y are two sequences
    of the same length"""

    slope = (y[-1] - y[0]) / (x[-1]-x[0])

    intercept = 0
    for i in range(len(y)):
        intercept = intercept + y[i] - slope*x[i]
    intercept = intercept / len(y)
    print("slope:", slope, " intercept:", intercept)
    matplotlib.pyplot.plot(x, y)
    matplotlib.pyplot.plot([x[0], x[-1]],
        [slope*x[0]+intercept, slope*x[-1]+intercept]) 


# linear regression for Australia data
linear_regression(years, gdp_au)

# uncomment to do linear regression for USA data
#linear_regression(years, gdp_us)
